// ****************************************************************
// Sketch Sonoff Dual Connect Modular(Tab) mit optischer Anzeige
// created: Jens Fleischer, 2018-06-16
// last mod: Jens Fleischer, 2020-12-21
// ****************************************************************
// Hardware: Sonoff Dual
// Software: Esp8266 Arduino Core 2.4.2 - 2.7.4
// Getestet auf: Sonoff Dual
/******************************************************************
  Copyright (c) 2018 Jens Fleischer. All rights reserved.

  This file is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.
  This file is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.
*******************************************************************/
// Diese Version von Connect sollte als Tab eingebunden werden.
// #include <ESP8266WebServer.h> muss im Haupttab aufgerufen werden
// Die Funktionalität des ESP8266 Webservers ist erforderlich.
// Die Funktion "connectWifi();" muss im Setup eingebunden werden.
// Dieser Connect Tab ist speziell für das Sonoff Dual.
/**************************************************************************************/

void connectWifi() {                                 // Funktionsaufruf "connectWifi();" muss im Setup eingebunden werden.
  const char* ssid = "Netzwerkname";                 // Darf bis zu 32 Zeichen haben.
  const char* password = "PasswortvomNetzwerk";      // Mindestens 8 Zeichen jedoch nicht länger als 64 Zeichen.
  constexpr uint8_t LEDPIN = 13;                     // Oneboard Led Sonoff Dual (blue)
  uint8_t i = 0;
  pinMode(LEDPIN, OUTPUT);
  WiFi.persistent(false);                            // Auskommentieren wenn Netzwerkname und Passwort in den Flash geschrieben werden sollen.
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(50);
    digitalWrite(LEDPIN, millis() % 500 >= 250);
    if (++i > 240) ESP.restart();
  }
  digitalWrite(LEDPIN, HIGH);
}
