// ****************************************************************
// Sketch Esp8266 Sonoff Dual Modular(Tab)
// created: Jens Fleischer, 2018-06-15
// last mod: Jens Fleischer, 2020-12-26
// For more information visit: https://fipsok.de
// ****************************************************************
// Hardware: Sonoff Dual
// Software: Esp8266 Arduino Core 2.7.2 - 2.7.4
// Getestet auf: Sonoff Dual
/******************************************************************
  Copyright (c) 2018 Jens Fleischer. All rights reserved.

  This file is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.
  This file is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.
*******************************************************************/
// Diese Version von Sonoff Dual sollte als Tab eingebunden werden.
// #include <ESP8266WebServer.h> muss im Haupttab aufgerufen werden.
// Die Funktionalität des ESP8266 Webservers ist erforderlich.
// Die Funktion "sonoffDual();" muss im Setup aufgerufen werden.
/**************************************************************************************/

void sonoffDual() {
  server.on("/status", []() {                                   // sendet den Schaltzustand an die Webseite
    server.enableCORS(true);
    server.send(200, "application/json", "[\"" + static_cast<String>(relState[0]) +  "\",\"" + static_cast<String>(relState[1]) + "\"]");
  });
  server.on("/hand10W", []() {                                  // Taster vom Sketch Heizung
    relState[0] = !relState[0];
    timeDataLogger(0, server.client().remoteIP().toString());   // Funktionsaufruf Zeitdatenlogger
    server.send(200, "text/plain", "10W OK Heizung");
  });
  server.on("/hand30W", []() {                                  // Taster vom Sketch Heizung
    relState[1] = !relState[1];
    timeDataLogger(1, server.client().remoteIP().toString());   // Funktionsaufruf Zeitdatenlogger
    server.send(200, "text/plain", "30W OK Heizung");
  });
  ArduinoOTA.onStart([]() {
    save();                                                     // Betriebstunden(Minuten) speichern
    Serial.write(0xA0);
    Serial.write(0x04);
    Serial.write(0x00);                                         // beide Relais ausschalten
    Serial.write(0xA1);
    Serial.write("\n");
    Serial.flush();
  });
}

void sonoffRelay_1() {
  Serial.write(0xA0);
  Serial.write(0x04);
  if (relState[0]) {
    relState[1] ? Serial.write(0x03) : Serial.write(0x01);
  }
  else {
    relState[1] ? Serial.write(0x06) : Serial.write(0x00);
  }
  Serial.write(0xA1);
  Serial.write("\n");
  Serial.flush();
}

void sonoffRelay_2() {
  Serial.write(0xA0);
  Serial.write(0x04);
  if (relState[1]) {
    relState[0] ? Serial.write(0x03) : Serial.write(0x02);
  }
  else {
    relState[0] ? Serial.write(0x05) : Serial.write(0x00);
  }
  Serial.write(0xA1);
  Serial.write("\n");
  Serial.flush();
}
